/*------------------------------------------------------------
  MK.JS  -     GPS-  (Java Script)
History:
  Author:  Comissar
  Created: 29.05.2012 -  
  Updates: 02.06.2012 - GPS,  , Excel-
  Updates: 03.06.2012 -    
  Updates: 04.06.2012 -    1.0.  ( ) .1.0: 
                        (D & T & KPI  , ,  GPSLIB.RU, GPSIES.COM)
  Updates: 07.06.2012 -    
  Updates: 11.06.2012 -   
-------------------------------------------------------------*/

//------------------------------------------------------------
//                   Globals constants
//------------------------------------------------------------
var log_File  = "MK.LOG";
var js_File   = "mk.js";
//............................................................
//                  GPS GEO CONSTANTS
//............................................................
var nEARTH_RADIUS = 6372795;     // metres
var nGEOSEC       = 360.*60.*60.;
var nDM_GPS       = (2. * Math.PI * nEARTH_RADIUS) / nGEOSEC;
var nGEOMINSEC    = 60.*60.;
var nDS_GPS       = 1. / nGEOMINSEC;
var nDS_BORDER    = 1.;  // old value = 5.
var cfDS0         = nDS_BORDER*nDS_GPS;
var cfDM0         = nDM_GPS * 10.;
var toDegrees     = 360. / (2. * Math.PI);
var toRadians     = (2. * Math.PI) / 360.;
var cfDX0         = 0.000001;
var cfDY0         = 0.000001;
var cfMAX_SPEED   = 20.;         // ~20  m/sec
var cfMIN_SPEED   = 1;           //  ~1  m/sec
var nDM0_KT       = 10;          // D  KT   ! 
//............................................................
//  Global Workers
//............................................................
var sDB_DIR = "";                // Working directory for JS 
var SEP = ", ";
//............................................................
//  Global Objects
//............................................................
var oExcel, oApp, oBook, oSheet; // Excel-report
//............................................................

//-----------------------------------------------------------
//                        M A I N
//-----------------------------------------------------------
{
var fso     = new ActiveXObject("Scripting.FileSystemObject");

var args    = WScript.arguments;
var argc    = args.length;
var sMode    = "";
var sFileAct = "";
var sFilePlan= "";
var sFileWPT = "";
var sReport  = "";
var nReport  = "";
var sDate    = "";
var oAct, oPlan, oWpt;     //   . , . ,  
					ODT( "MAIN", "BEGIN" );
  GetCurrentDirectory();                ODT( "", sDB_DIR );

  if( argc>0 )
  {
    sMode = args.item(0);               ODT( "MAIN", sMode );

   if( sMode=="GPS" )   // ------  GPS- ----
   {
//             .  .               a DATE
//cscript.exe mk.js GPS   Eremey     MK_151_KM.gpx MK_151_GPX_WPT.gpx Report.xls 2        21_04_2012

     // -- 1. --   ,  GP-,   
     
     sFileAct = args.item(1);         // ----    (Actual) GPS-
     if( fso.FileExists(sDB_DIR+"\\"+sFileAct+".GPX")==false ) ODT( sDB_DIR+"\\"+sFileAct+".GPX", "false" );
     oAct = new gps_Array( "GPX" );   
     oAct.LoadFile( sFileAct+".GPX", "trkpt" );

     sFilePlan = args.item(2);        // ----   GPS-
     if( fso.FileExists(sDB_DIR+"\\"+sFilePlan)==false ) ODT( sDB_DIR+"\\"+sFilePlan, "false" );
     oPlan = new gps_Array( "GPX" );  
     oPlan.LoadFile( sFilePlan, "trkpt" );

     sFileWPT = args.item(3);         // ----  WPT ( )
     if( fso.FileExists(sDB_DIR+"\\"+sFileWPT)==false) ODT( sDB_DIR+"\\"+sFileWPT, "false" );
     oWpt = new gps_Array( "GPX" );   
     oWpt.LoadFile( sFileWPT, "wpt" );      

ODT( "MAIN", "-------------oWpt.View();-------------" );
oWpt.View( "oWpt.View" );

     // ---- Report                   
     sReport = args.item(4);          // ----   Excel-
     nReport = args.item(5);          // ----        
     sDate   = args.item(6);          // ----        

     // -- 2. --     

     // 2.1   (Border)  GPS-  OK
     oPlan.CreateBorder( "oPlan" );

     // 2.2   ( )   
     oPlan.SetControlPoints( oWpt.aLat, oWpt.aLong, oWpt.aID );    

     // 2.3   ( )   
     oAct.SetControlPoints( oWpt.aLat, oWpt.aLong, oWpt.aID );     

     // 2.5        (by Latitude & Longtitude Border)
     oAct.SetActualPoints( oPlan.aLat_B, oPlan.aLong_B ); 

     // 2.6       
     oAct.SetMovingPoints(); 

ODT( "MAIN", "-------------oPlan.View();-------------" );
//   oPlan.View( "oPlan.View" );
ODT( "MAIN", "-------------oAct.View();-------------" );
//   oAct.View( "oAct.View" );

     // 2.7    Distance   

     fPlanDistanceFull    = 0.+oPlan.GetDistance( "FULL", "" ) /1000.;             //   D ( )
		ODT( "MAIN", "fPlanDistanceFull="+fPlanDistanceFull );
     fActDistanceFull     = 0.+oAct.GetDistance(  "FULL", "" ) /1000.;             //   D ( )
		ODT( "MAIN", "fActDistanceFull="+fActDistanceFull );
     fActDistancePlanFull = 0.+oAct.GetDistance( "PLAN_FULL", "" ) /1000.;         //    .  
		ODT( "MAIN", "fActDistancePlanFull="+fActDistancePlanFull );
     fActDistanceMoveFull = 0.+oAct.GetDistance(  "MOVE_FULL", "" ) /1000.;        //   +  
		ODT( "MAIN", "fActDistanceMoveFull="+fActDistanceMoveFull );
     fActDistancePlanMove = 0.+oAct.GetDistance(  "PLAN_MOVE", "" ) /1000.;        //   +  
		ODT( "MAIN", "fActDistancePlanMove="+fActDistancePlanMove );
//---- KT
     fPlanDistanceStep    = 0.+oPlan.GetDistance( "STEP", "KT1,KT2,") /1000.;       // D   1  2  
//		ODT( "MAIN", "fPlanDistanceStep="+fPlanDistanceStep );
     fActDistanceStep     = 0.+oAct.GetDistance(  "STEP", "KT1,KT2,") /1000.;  
//		ODT( "MAIN", "fActDistanceStep="+fActDistanceStep );
     fActDistancePlanStep = 0.+oAct.GetDistance( "PLAN_STEP", "KT1,KT2," ) /1000.;  //      KT .  
//		ODT( "MAIN", "fActDistancePlanStep="+fActDistancePlanStep );
     fActDistanceMoveStep = 0.+oAct.GetDistance(  "MOVE_STEP", "KT1,KT2," ) /1000.;        
//		ODT( "MAIN", "fActDistanceMoveStep="+fActDistanceMoveStep );


     // 2.8    Time   

     fActTimeFull     = 0.+oAct.GetTime( "FULL", "" );                   // T   ( )
		ODT( "MAIN", "fActTimeFull="+fActTimeFull );
     fActTimeFullStop = 0.+oAct.GetTime( "STOP", "" );                   // T   
		ODT( "MAIN", "fActTimeFullStop="+fActTimeFullStop );
     fActTimePlanFull = 0.+oAct.GetTime( "PLAN_FULL", "" );              //    .  
		ODT( "MAIN", "fActTimePlanFull="+fActTimePlanFull );
     fActTimeMoveFull = 0.+oAct.GetTime( "MOVE_FULL", "" );              //   +  
		ODT( "MAIN", "fActTimeMoveFull="+fActTimeMoveFull );
     fActTimePlanMove = 0.+oAct.GetTime(  "PLAN_MOVE", "" ) /1000.;        //   +  
		ODT( "MAIN", "fActTimePlanMove="+fActTimePlanMove );
//---- KT
     fActTimeStep     = 0.+oAct.GetTime( "STEP", "KT1,KT2,");             // T   1  2  
//		ODT( "MAIN", "fActTimeStep="+fActTimeStep );
     fActTimePlanStep = 0.+oAct.GetTime( "PLAN_STEP", "KT1,KT2," );       //      KT .  
//		ODT( "MAIN", "fActTimePlanStep="+fActTimePlanStep );
     fActTimeMoveStep = 0.+oAct.GetTime( "MOVE_STEP", "KT1,KT2," );        
//		ODT( "MAIN", "fActTimeMoveStep="+fActTimeMoveStep );


     // 2.9    (KPI)
//         ( ,   , )
//   KPI1 = fActDistancePlanFull / fPlanDistanceFull * 100.;
     KPI1 = fActDistancePlanFull / fActDistanceFull * 100.;           // OK OK OK

//        (   , )
     KPI2 = fActTimePlanFull / fActTimeFull * 100.;

//   \ V  K (, )
     KPI3 = fActDistancePlanFull*1000. / fActTimePlanFull *3.6;
     KPI4 = fActDistanceMoveFull*1000. / fActTimeMoveFull *3.6;      // OK OK OK
     KPI5 = fActDistancePlanMove*1000. / fActTimePlanMove *3.6;

     // 2.10  Excel-
     if( fso.FileExists(sDB_DIR+"\\"+sReport)==false ) ODT( "sReport", "false" );

     if( xlsOpen( sDB_DIR+"\\"+sReport ) ) 
     {
/***
       xlsPutVal( 1, "A1", "" );
       xlsPutVal( 1, "B1", " " );
       xlsPutVal( 1, "C1", " (D) " );

       xlsPutVal( 1, "A"+nReport, sFileAct );
       xlsPutVal( 1, "B"+nReport, sDate    );
       xlsPutVal( 1, "C"+nReport, fPlanDistanceFull );
***/

/***
       xlsPutVal( 1, "D1", " D-.     D" );   // KPI1
       xlsPutVal( 1, "E1", " T-.     T" );  // KPI2
       xlsPutVal( 1, "F1", " V /  " );             // KPI3
       xlsPutVal( 1, "G1", " V /   " );             // KPI4
       xlsPutVal( 1, "H1", ",  V /" );

       xlsPutVal( 1, "D"+nReport, KPI1 );
       xlsPutVal( 1, "E"+nReport, KPI2 );
       xlsPutVal( 1, "F"+nReport, KPI3 );
       xlsPutVal( 1, "G"+nReport, KPI4 );
       xlsPutVal( 1, "H"+nReport, KPI5 );
***/
/***
       xlsPutVal( 1, "D1", "  D-.     D" );  // KPI1
       xlsPutVal( 1, "E1", " V /  " );                      // KPI4
       xlsPutVal( 1, "D"+nReport, KPI1 );
       xlsPutVal( 1, "E"+nReport, KPI4 );
***/

       xlsPutVal( 1, "E"+nReport, sFileAct );
       xlsPutVal( 1, "F"+nReport, sDate    );
       xlsPutVal( 1, "G"+nReport, fPlanDistanceFull );
       xlsPutVal( 1, "H"+nReport, KPI1 );
       xlsPutVal( 1, "I"+nReport, KPI4 );

       xlsClose(); 
     }
   } // ---- if( sMode=="GPX" )

   if( sMode=="FOTO" )   // ------   ----
   {
     // ----    (Actual) GPS-   
     sFileAct = args.item(1);         

     // ----   GPS-
     sFilePlan = args.item(2);  oPlan = new gps_Array( "GPX" );  oPlan.LoadFile( sFilePlan, "trkpt" );

     // ----  WPT ( )
     sFileWPT = args.item(3);   oWpt = new gps_Array( "GPX" );   oWpt.LoadFile( sFileWPT, "wpt" );      
     oWpt.View( "oWpt.View" );

     oPlan.SetControlPoints( oWpt.aLat, oWpt.aLong, oWpt.aID );    
     fPlanDistanceFull = 0.+oPlan.GetDistance( "FULL", "" ) /1000.;  //   D ( )

     // ---- Report                   
     sReport = args.item(4);      // ----   Excel-
     nReport = args.item(5);      // ----        
     sDate   = args.item(6);      // ----        

     var fso = new ActiveXObject("Scripting.FileSystemObject");
     var f   = fso.GetFolder("Comissar");
     var fc   = new Enumerator(f.files);
     var sF= "";
     var s1= "";
     var s2= "";
     var s3= "";
     var f = "";
     var a = new Array();
     var aD= new Array();
     var i = 0;
     for (; !fc.atEnd(); fc.moveNext())
     {
// 1 -     
       sF = ""+fc.item();
       s1 = sF.substring( sF.lastIndexOf("\\")+1, sF.length ); ;  ODT( "MAIN "+sMode, s1 );
       f  = fso.GetFile( sF );                                 
       s2 = ""+f.DateLastModified;             ODT( "MAIN "+sMode, s2 );
       a  = s2.split( " " );
       s3 = a[3];                           ODT( "MAIN "+sMode, s3 );  // seconds !
// 2 -   s3 ( ) 
// 3 -    oAct      
// 4 -      ()
       aD[i] = ""+s3;  i++;
     }

/***
                    .                 
cscript.exe mk.js FOTO  Comissar   MK_151_KM.gpx MK_151_GPX_WPT.gpx  Report.xls  11
***/
     if( xlsOpen(sDB_DIR +"\\" +sReport) ) 
     {
       xlsPutVal( 2, "A1", "" );
       xlsPutVal( 2, "B1", " " );
       xlsPutVal( 2, "C1", " (D) " );
       xlsPutVal( 2, "D1", "KT1" );
       xlsPutVal( 2, "E1", "KT2" );
       xlsPutVal( 2, "F1", "KT3" );
       xlsPutVal( 2, "G1", "KT4" );
       xlsPutVal( 2, "H1", "KT5" );
       xlsPutVal( 2, "I1", "KT6" );
       xlsPutVal( 2, "J1", "KT7" );
       xlsPutVal( 2, "K1", "KT8" );
       xlsPutVal( 2, "L1", "KT9" );
       xlsPutVal( 2, "M1", "KT10" );
       xlsPutVal( 2, "N1", "KT11" );
       xlsPutVal( 2, "O1", "KT12" );
       
       xlsPutVal( 2, "A"+nReport, sFileAct );
       xlsPutVal( 2, "B"+nReport, sDate    );
       xlsPutVal( 2, "C"+nReport, fPlanDistanceFull );

       xlsPutVal( 2, "D"+nReport, aD[0] );
       xlsPutVal( 2, "E"+nReport, aD[1] );
       xlsPutVal( 2, "F"+nReport, aD[2] );
       xlsPutVal( 2, "G"+nReport, aD[3] );
       xlsPutVal( 2, "H"+nReport, aD[4] );
//...
       xlsClose(); 
     }
   } // ---- if( sMode=="FOTO" )
  } // ---- if( argc>0 )
ODT( "MAIN", "---- END! ----" );
} // ---- MAIN

//------------------------------------------------------------
//
//                   CLASS: gps_Array   
//
// Class.Function: gps_Array.LoadFile
//------------------------------------------------------------
function gps_LoadFile( sFile, sRecName )
{
ODT( "gpx_LoadFile",  "BEGIN"  );

  this.xml.async = false;   
  this.xml.load( sFile ); 
  this.sFile = sFile; 

//<trkpt lat="53.92" lon="27.60"> <ele>226.00000</ele> <time>2012-05-08T16:39:56Z</time></trkpt>
//<wpt lat="53.882488000" lon="27.726059000"><time>2012-05-25T13:50:56Z</time><name>KT2</name><cmt></cmt><desc> </desc></wpt>
  
  var oArray1 =this.xml.getElementsByTagName( sRecName );  // "trkpt", "wpt"
  var sTime   = "";
  var sValue  = "";

  if(oArray1)   
  for(var i=0; i<oArray1.length; i++)   
  {   
    var Obj1      = oArray1[i];
    var sLat      = ""+Obj1.attributes.getNamedItem("lat").nodeValue;  // ODT( "sLat",  sLat  );
    var sLong     = ""+Obj1.attributes.getNamedItem("lon").nodeValue;  // ODT( "sLong", sLong );
    if( Obj1.childNodes[1].nodeName=="time" ) sValue = Obj1.childNodes[1].text;
    if( Obj1.childNodes[0].nodeName=="time" ) sValue = Obj1.childNodes[0].text;
                                                                       // ODT( "sValue", sValue );
    var d         = new Date(); 

    this.aMov[i] = 0;       // 1 -  ""        
    this.aRes[i] = 0;       // 1 -  ""       
    this.aKT[i]  = 0;       // 1 -  ""    
    this.aID[i]  = "0000";  // ID-    

    if( sRecName=="trkpt" )
    {
      this.aLat[i]  = parseFloat(sLat);
      this.aLong[i] = parseFloat(sLong);
      d             = gpx_getDateTime( sValue ); //   GPX  
    }

    if( sRecName=="wpt" )
    {
     if( sValue.indexOf("KT")>=0 )  //      KT !!!!!
     {
      this.aLat[i]  = parseFloat(sLat);
      this.aLong[i] = parseFloat(sLong);
      this.aKT[i]   = 1;                         // 1 :  -     
      this.aID[i]   = sValue;                    //     
     }

    }
    this.aTime[i] = d;                           //  - 
  }
ODT( "gpx_LoadFile",  "END"  );
}
//-----------------------------------------------------------
// Class.Function: gps_Array.View
//-----------------------------------------------------------
function gps_View( sText )
{
  ODT( "----gps_View----", sText );

  for(var i=0; i<this.aLat.length; i++)   
  {   
   ODT( "i,Lat,Long,Time,Mov,Res,aKT,ID_KT", (i+1)+SEP 
      +this.aLat[i]+SEP 
      +this.aLong[i]+SEP 
//    +this.aTime[i].toString()+SEP 
      +_dt2str( this.aTime[i] )+SEP 
      +this.aMov[i]+SEP 
      +this.aRes[i]+SEP 
      +this.aKT[i]+SEP 
      +this.aID[i] ); 
  }
}
//-----------------------------------------------------------
// Class.Function: gps_Array.CreateBorder
//
//     GPS-   
// . ,     (~5 geo sec)
//-----------------------------------------------------------
function gps_CreateBorder( sText )
{
  ODT( "gps_CreateBorder: --1-- ", sText );

  var aY1  = new Array();  // Latitude Border    Y    Internal
  var aX1 = new Array();   // Longtitude Border  X
  var aY2  = new Array();  // Latitude Border    Y    External
  var aX2 = new Array();   // Longtitude Border  X

  var nMove  = 1;   // Variants Moving
  var nAngle = 1;   // Variants Angle Moving

  var x1=0., y1=0., dx1=0., dy1=0.;

  var nLen = this.aLat.length-2;

  for(var i=0; i<nLen; i++)
  {   
     x1 = this.aLong[i];  dx1 = this.aLong[i+1] - x1;  if( dx1==0.) dx1=cfDX0;
     y1 = this.aLat[i];   dy1 = this.aLat[i+1]  - y1;  if( dy1==0.) dy1=cfDY0;
   
     // ---- Variants Moving
     if( dy1>=cfDY0 && dx1>=cfDX0 ) nMove = 1;  // ---- Left  & Up 
     if( dy1<=cfDY0 && dx1>=cfDX0 ) nMove = 2;  // ---- Right & Up ...
     if( dy1<=cfDY0 && dx1<=cfDX0 ) nMove = 3;  // ---- Right & Down
     if( dy1>=cfDY0 && dx1<=cfDX0 ) nMove = 4;  // ---- Left  & Down
   
     // ---- Variants Angle
     if(  Math.abs(dy1) <  Math.abs(dx1) ) nAngle = 1;  // <45 degrees
     if(  Math.abs(dy1) >= Math.abs(dx1) ) nAngle = 2;  // >45 degrees
   
     // ---- Simple default filling
     aX1[i]=x1-cfDS0; aY1[i]=x1+cfDS0;  // External array
     aX2[i]=y1+cfDS0; aY2[i]=y1-cfDS0;  // Internal array
   
     // ---- Actual filling
     if( nMove==1  )               // ---- nMove=1  Left  & Up 
     {
       if( nAngle==1 )
       {
        // External         Internal
        //....................................
        aX1[i]=x1;       aX2[i]=x1;
        aY1[i]=y1+cfDS0; aY2[i]=y1-cfDS0;
       }
       if( nAngle==2 )
       {
        aX1[i]=x1-cfDS0; aX2[i]=x1+cfDS0;
        aY1[i]=y1;       aY2[i]=y1;
       }
     }
     if( nMove==2  )              // ---- nMove=2 Right & Up ...
     {
      if( nAngle==1 )
      {
       aX1[i]=x1;        aX2[i]=x1;
       aY1[i]=y1+cfDS0;  aY2[i]=y1-cfDS0;
      }
      if( nAngle==2 )
      {
       aX1[i]=x1+cfDS0;  aX2[i]=x1-cfDS0;
       aY1[i]=y1;        aY2[i]=y1;
      }
     }
     if( nMove==3 )                // ---- nMove=3  Right & Down
     {
      if( nAngle==1 )
      {
       aX1[i]=x1;        aX2[i]=x1;
       aY1[i]=y1-cfDS0;  aY2[i]=y1+cfDS0;
      }
      if( nAngle==2 )
      {
       aX1[i]=x1+cfDS0;  aX2[i]=x1-cfDS0;
       aY1[i]=y1;        aY2[i]=y1;
      }
     }
     if( nMove==4 )              // ---- nMove=4 Left  & Down
     {
      if( nAngle==1 )
      {
       aX1[i]=x1;        aX2[i]=x1;
       aY1[i]=y1-cfDS0;  aY2[i]=y1+cfDS0;
      }
      if( nAngle==2 )
      {
       aX1[i]=x1-cfDS0;  aX2[i]=x1+cfDS0;
       aY1[i]=y1;        aY2[i]=y1;
      }
     }
//   ODT( "x,y, dx,dy, M,A, x1,y1, x2,y2",      +x1+SEP +y1+SEP +dx1+SEP +dy1+SEP +nMove+SEP +nAngle+SEP  +aX1[i]+SEP +aY1[i]+SEP +aX2[i]+SEP +aY2[i] );
  } // for(var i=0; i<nLen-1; i++)

  // ---- Create Actual Border Polygon
  for(var i=0; i<nLen; i++)
  {   
    this.aLat_B[i]       = aY1[i];  // Latitude Border    Y    Internal  
    this.aLong_B[i]      = aX1[i];  // Longtitude Border  X              
    this.aLat_B[i+nLen]  = aY2[i];  // Latitude Border    Y    External  
    this.aLong_B[i+nLen] = aX2[i];  // Longtitude Border  X              
  }
  ODT( "gps_CreateBorder: --2-- OK ", sText );
}

//-----------------------------------------------------------
// Class.Function: gps_Array.SetControlPoints
//
//   (\),    ( )    (nKT)
//-----------------------------------------------------------
function gps_SetControlPoints( aLat_WPT, aLong_WPT, aID_WPT )
{
  ODT( "gps_SetControlPoints", "BEGIN" );

  for(var n=0; n<aLat_WPT.length; n++)          //   
  {
    long1 = aLong_WPT[n];   lat1 = aLat_WPT[n]; 

    for(var i=0; i<this.aLat.length; i++)       //   GPS-
    {
      long2 = this.aLong[i];  lat2 = this.aLat[i]; 

      dist  = gps_getGeoDistance( lat1, long1, lat2, long2 ); 
      if( dist<=(cfDM0*nDM0_KT) ) 
      {
        this.aKT[i] = n+1;         // +1  (   aLat_WPT, aLong_WPT)
        this.aID[i] = aID_WPT[n];  //  KT
ODT( "dist<=cfDM0, n+1, ID", (n+1)+SEP +aID_WPT[n] );
        break; 
      }
    }
  }
  ODT( "gps_SetControlPoints", "END" );
}

//-----------------------------------------------------------
// Class.Function: gps_Array.SetActualPoints
//       
//----------------------------------------------------------
function gps_SetActualPoints( aLat_B, aLong_B ) 
{
  ODT( "gps_SetActualPoints", "BEGIN" );

  var x=0., y=0.;
  for(var i=0; i<this.aLat.length; i++)
  {  
    x = this.aLong[i]; y = this.aLat[i]; this.aRes[i]=0;  
    if (isPinPolyArray( x, y, aLong_B, aLat_B )==1) 
      this.aRes[i]=1; //  -  !
  }

//ODT
  index=0;
  for(var i=0; i<this.aLat.length; i++)
  {  
    if( this.aRes[i]==1 ) index++;
  }
  ODT( "gps_SetActualPoints", "length_full="+this.aLat.length );
  ODT( "gps_SetActualPoints", "length_sRes="+index );
  ODT( "gps_SetActualPoints", "END" );
}

//-----------------------------------------------------------
// Class.Function: gps_Array.SetMovingPoints
//       
//-----------------------------------------------------------
function gps_SetMovingPoints()
{
  ODT( "gps_SetMovingPoints", "BEGIN" );

  var dist=0., dTime=0., long1=0., lat1=0., long2=0., lat2=0., V=0.;

  for( var i=0; i<this.aLat.length-2; i++ )
  {  
    long1 = this.aLong[i];    lat1 = this.aLat[i]; 
    long2 = this.aLong[i+1];  lat2 = this.aLat[i+1]; 

    dist  = gps_getGeoDistance(lat1, long1, lat2, long2 ); 
    dTime = getTimeInterval( this.aTime[i], this.aTime[i+1] ); 

    V     = dist / (dTime +cfDX0);
    this.aMov[i]=-1;                                  // GPS-    !
    if( (V>=cfMIN_SPEED) && (V<cfMAX_SPEED) ) this.aMov[i]=1;    //  -  !
  }
//ODT
  index=0;
  for(var i=0; i<this.aLat.length; i++)
  {  
    if( this.aMov[i]==1 ) index++;
  }
  ODT( "gps_SetMovingPoints", "length_full="+this.aLat.length );
  ODT( "gps_SetMovingPoints", "length_aMov="+index );
  ODT( "gps_SetMovingPoints", "END" );
}

//-----------------------------------------------------------
// Class.Function: gps_Array.GetTime
//      
//-----------------------------------------------------------
function gps_GetTime( What1, What2 )
{
//ODT( "gps_GetTime", "BEGIN" );

  var nTime=cfDX0, dTime=0.;

  for( var i=0; i<(this.aLat.length-2); i++ )
  {  
    Mov1  = this.aMov[i];   Mov2 = this.aMov[i+1]; 
    Res1  = this.aRes[i];   Res2 = this.aRes[i+1]; 

    dTime = 0; 
    switch( What1 ) 
    {
     case "FULL":   
              dTime = getTimeInterval( this.aTime[i], this.aTime[i+1] ); 
          break;

     case "STOP":        
          if( (Mov1==-1) && (Mov2==-1) ) 
              dTime = getTimeInterval( this.aTime[i], this.aTime[i+1] ); 
          break;

     case "MOVE_FULL":   
          if( (Mov1==1) && (Mov2==1) ) 
              dTime = getTimeInterval( this.aTime[i], this.aTime[i+1] ); 
          break;

     case "PLAN_FULL":   
          if( (Res1==1) && (Res2==1) ) 
              dTime = getTimeInterval( this.aTime[i], this.aTime[i+1] ); 
          break;

     case "PLAN_MOVE":   
          if( (Res1==1) && (Res2==1) || (Mov1==1) && (Mov2==1) ) 
              dTime = getTimeInterval( this.aTime[i], this.aTime[i+1] ); 
          break;

     case "STEP":       // ODT( "gps_GetTime", What2 );     
          break;
     case "PLAN_STEP":  // ODT( "gps_GetTime", What2 );     
          break;
     case "MOVE_STEP":  // ODT( "gps_GetTime", What2 );     
          break;

     default:  
          break;
    }
    nTime = nTime + dTime;
  }
//ODT( "gps_GetTime", "END" );
  return nTime;
}

//-----------------------------------------------------------
// Class.Function: gps_Array.GetDistance
//      
//-----------------------------------------------------------
function gps_GetDistance( What1, What2 )
{
//ODT( "gps_GetDistance", "BEGIN" );

  var nDistSum = cfDX0, nDist=0.;
  var long1=0., lat1=0., long2=0., lat2=0.;

  for( var i=0; i<this.aLat.length-2; i++ )
  {  
    long1 = this.aLong[i];    lat1 = this.aLat[i]; 
    long2 = this.aLong[i+1];  lat2 = this.aLat[i+1]; 
    Mov1  = this.aMov[i];     Mov2 = this.aMov[i+1]; 
    Res1  = this.aRes[i];     Res2 = this.aRes[i+1]; 

    nDist = 0; 
    switch( What1 ) 
    {
     case "FULL":   
             nDist = gps_getGeoDistance( lat1, long1, lat2, long2 ); 
          break;
  
     case "MOVE_FULL":   
          if( (Mov1==1) && (Mov2==1) ) 
             nDist = gps_getGeoDistance( lat1, long1, lat2, long2 ); 
          break;

     case "PLAN_FULL":   
          if( (Res1==1) && (Res2==1) ) 
             nDist = gps_getGeoDistance( lat1, long1, lat2, long2 ); 
          break;

     case "PLAN_MOVE":   
          if( (Res1==1) && (Res2==1) || (Mov1==1) && (Mov2==1) ) 
             nDist = gps_getGeoDistance( lat1, long1, lat2, long2 ); 
          break;

     case "STEP":       // ODT( "gps_GetDistance", What2 );     
          break;

     case "PLAN_STEP":  // ODT( "gps_GetDistance", What2 );     
          break;

     case "MOVE_STEP":  // ODT( "gps_GetDistance", What2 );     
          break;

     default:  
          break;
    }
    nDistSum = nDistSum + nDist;
  }
//ODT( "gps_GetDistance", "END" );
  return nDistSum;
}

//-----------------------------------------------------------
function gps_Array( sFileType )
{
  this.xml    = new ActiveXObject("Microsoft.XMLDOM");
  this.sFileType = sFileType;
  this.aLat   = new Array();    // Latitude   -   (Y /!\)
  this.aLong  = new Array();    // Longtitude -  (X -->)
  this.aTime  = new Array();    //     - 

  this.aLat_B  = new Array();   // Latitude Border
  this.aLong_B = new Array();   // Longtitude Border

  this.aMov = new Array();     // 1 -  ""        
  this.aRes = new Array();     // 1 -  ""       
  this.aKT  = new Array();     // 1 -  ""    
  this.aID  = new Array();     //    

  this.LoadFile         = gps_LoadFile;          // Load & Parse GPX\WPT XML-file
  this.View             = gps_View;              // Test view 
  this.CreateBorder     = gps_CreateBorder;      // Create Border aroud Plan Track
  this.SetControlPoints = gps_SetControlPoints;  // Set Control Points from WPT
  this.SetActualPoints  = gps_SetActualPoints;   // Set Result Points by Plan Track
  this.SetMovingPoints  = gps_SetMovingPoints;   // Set Moving Points (V>1 m/sec)
  this.GetDistance      = gps_GetDistance;       // Get distance value for Indicators
  this.GetTime          = gps_GetTime;           // Get time value for Indicators
}

//-----------------------------------------------------------
//                      
//-----------------------------------------------------------


//-----------------------------------------------------------
//        ::
//-----------------------------------------------------------
function _getTime()
{
  now      = new Date();

  nHours   = now.getHours();
  nMinutes = now.getMinutes();
  nSeconds = now.getSeconds();
  nMS      = now.getMilliseconds();

  var sH   = "";
  if( nHours<10 ) sH = "0" + nHours;
  else            sH =  nHours;

  var sM   = "";
  if( nMinutes<10 ) sM = "0" + nMinutes;
  else              sM = nMinutes;

  var sS   = "";
  if( nSeconds<10 ) sS = "0" + nSeconds;
  else              sS = nSeconds;

  var sTime = "";
  sTime = sH + ":" + sM + ":" + sS;
  return sTime;
}
//-----------------------------------------------------------
//        sFile = log_File;  
//-----------------------------------------------------------
function ODT( sNote, sText ) 
{
  var oFS   = new ActiveXObject("Scripting.FileSystemObject");
  var sFile = log_File;
  var oF;
  
  // File exists
  if( oFS.FileExists(sFile) )
  {
    oF = oFS.OpenTextFile( sFile, 8, false );

    var sD="";
    var s = new String(sNote);
    for( var i=0; i<(20-s.length); i++) sD = sD + " ";
    var sTmp = _getTime()+"|" +sNote + sD +" | " + sText;

    oF.WriteLine( sTmp );
    oF.Close();
  }
  // File doesn't exists
  else
  {
    oF = oFS.CreateTextFile( sFile, true );
    oF.Close();
    if( oFS.FileExists(sFile) )
    {
      oF = oFS.OpenTextFile( sFile, 8, false );

      var sD="";
      var s = new String(sNote);
      for( var i=0; i<(20-s.length); i++) sD = sD + " ";
      var sTmp = _getTime()+"|" +sNote + sD +" | " + sText;

      oF.WriteLine( sTmp );
      oF.Close();
    }
  }
}
//-----------------------------------------------------------
//  Get Current Directory (without "\\" separator)
//-----------------------------------------------------------
function GetCurrentDirectory() 
{
  var oFS = new ActiveXObject("Scripting.FileSystemObject");
  var sFull = oFS.GetAbsolutePathName( js_File );

  var sTmp   = new String( sFull );
  var nx     = sTmp.indexOf( "\\" +js_File );
  sDB_DIR    = "" +sTmp.substr(0,nx+1);
}
//-------------------------------------------------------
// gps_getGeoDistance -       (Earth)
//      c    (lat)   (long) 
//-------------------------------------------------------
function gps_getGeoDistance(latA, longA, latB, longB) 
{  
var EARTH_RADIUS = 6372795;       

 lat1   = latA * Math.PI / 180;     
 lat2   = latB * Math.PI / 180;     
 long1  = longA * Math.PI / 180;     
 long2  = longB * Math.PI / 180;       
 cl1    = Math.cos(lat1);     
 cl2    = Math.cos(lat2);     
 sl1    = Math.sin(lat1);     
 sl2    = Math.sin(lat2);     
 delta  = long2 - long1;     
 cdelta = Math.cos(delta);     
 sdelta = Math.sin(delta);       
 y      = Math.sqrt(Math.pow(cl2 * sdelta, 2) + Math.pow(cl1 * sl2 - sl1 * cl2 * cdelta, 2));
 x      = sl1 * sl2 + cl1 * cl2 * cdelta;       
 ad     = Math.atan2(y, x);     
 dist   = Math.ceil(ad * EARTH_RADIUS);       
return dist; 
}
//-------------------------------------------------------
// gpx_getDateTime -    - 2012-05-08T16:39:56Z GPX-
//       GPS-          !
//-------------------------------------------------------
function gpx_getDateTime( sTime0 )
{
var n1 = sTime0.indexOf( "T" );
var n2 = sTime0.indexOf( "Z" );

var sDate = ""+sTime0.substr(   0,   n1);    //  ODT( "sDate", sDate );
var sTime = ""+sTime0.substr(n1+1,n2-n1-1);  //  ODT( "sTime", sTime );

  var aDate = new Array();  aDate=sDate.split("-");  
//                     for( var n=0; n<aDate.length; n++ ) ODT( "sD", aDate[n] ); 

  var aTime = new Array();  aTime=sTime.split(":");     
//                     for( var n=0; n<aTime.length; n++ ) ODT( "sT", aTime[n] ); 

  var nYY = parseInt(""+aDate[0]);
  var nMM = parseInt(""+aDate[1]);
  var nDD = parseInt(""+aDate[2]);

  var nH  = parseInt(""+aTime[0]);
  var nM  = parseInt(""+aTime[1]);
  var nS  = parseInt(""+aTime[2]);

  var d = new Date();

  d.setFullYear(nYY);
  d.setMonth(nMM);
  d.setDate(nDD);

  d.setHours(nH);
  d.setMinutes(nM);
  d.setSeconds(nS);

  return d;
}
//-----------------------------------------------------------
//                    Excel-
//-----------------------------------------------------------
function xlsOpen(sFile)  // sFile -full name (DirectoryName + "\\" + FileName)
{
  try
  {
    oExcel = new ActiveXObject("Excel.Application");
    oApp   = oExcel.Application;
  }
  catch( ex )
  {
   if( ex instanceof Error ) 
   { 
    ODT("xlsOpen", ""+ex.description );
    oExcel.Quit(); 
    return false; 
   }
   else  { throw ex; }
  }

  try
  {
//  ODT( "xlsOpen", sFile );
    oBook = oExcel.Workbooks.Open( sFile );
  }
  catch( ex )
  {
    if( ex instanceof Error ) 
    { 
     ODT("xlsOpen",  ""+ex.description );
     oExcel.Quit(); 
     return false; 
    }
    else { throw ex; }
  }
  return true; 
}
//-----------------------------------------------------------
function xlsClose() 
{
  oBook.Save();
  oBook.Close();     
  oExcel.Quit(); 
  return true; 
}
//-----------------------------------------------------------
// Demo usage:  xlsPutVal( 1, "A4", "Value for row=4, col=1 (4)" );
//-----------------------------------------------------------
function xlsPutVal( nPage, sCell, sValue ) 
{
  oSheet = oBook.Worksheets( nPage ); 
  oSheet.Range( sCell ).Value = sValue;
  return true; 
}
//-----------------------------------------------------------
function xlsGetVal( nPage, sCell ) 
{
var sValue="";
  oSheet = oBook.Worksheets( nPage ); 
  sValue = "" +TTS( oSheet.Range( sCell ).Value );
  return sValue; 
}
//-----------------------------------------------------------
// isPinPoly -  (1\0)  \ 
// x, y      - .   (float)
// aX, aY    - .     (float)
//-----------------------------------------------------------
function isPinPolyArray( x, y, aX, aY )
{
var i, j, c = 0;
var nLen = aX.length;;

    for (i = 0, j = nLen-1; i<nLen; j = i++) 
    {
       if( ( ((aY[i] <= y) && (y < aY[j])) ||
            ( (aY[j] <= y) && (y < aY[i]))) &&
            ( x < (aX[j] - aX[i]) * (y - aY[i]) / (aY[j] - aY[i]) + aX[i]) )
       c = 1;
    }
    return c;
}
//-----------------------------------------------------------
//          !
//-----------------------------------------------------------
function getTimeInterval( oTime1, oTime2 )
{
var dTime=0., nT1=0., nT2=0.;

//nY1 = oTime1.getFullYear();   //   (    1970)
  nMn1 = oTime1.getMonth()+1;
  nD1 = oTime1.getDate();
  nH1 = oTime1.getHours();
  nM1 = oTime1.getMinutes();
  nS1 = oTime1.getSeconds();
  nMs1= oTime1.getMilliseconds();
  nT1 = nMn1*30*24*60*60 +nD1*24*60*60 +nH1*60*60 +nM1*60 +nS1 +nMs1/1000.;

  nMn2= oTime2.getMonth()+1;
  nD2 = oTime2.getDate();
  nH2 = oTime2.getHours();
  nM2 = oTime2.getMinutes();
  nS2 = oTime2.getSeconds();
  nMs2= oTime2.getMilliseconds();
  nT2 = nMn2*30*24*60*60 +nD2*24*60*60 +nH2*60*60 +nM2*60 +nS2 +nMs2/1000.;

  dTime = nT2 - nT1;
  return dTime;
}

//----------------------------------------------------------
function _dt2str( oDT )
{
  nYear    = oDT.getFullYear();
  nMonth   = oDT.getMonth()+1;
  nDay     = oDT.getDate();
  nHours   = oDT.getHours();
  nMinutes = oDT.getMinutes();
  nSeconds = oDT.getSeconds();
  nMS      = oDT.getMilliseconds();
  S1       = "-";
  S2       = ":";
  sTime    = ""+nYear+S1+nMonth+S1+nDay +"  " +nHours+S2+nMinutes+S2+nSeconds; 
  return sTime;
}
//-----------------------------------------------------------


////////////
//  END
////////////

